import { a as _extends, c as _inheritsLoose } from './chunk-fb907809.js';
import React__default, { createElement, Component } from 'react';
import PropTypes__default, { func, string, oneOfType, arrayOf, bool, number, oneOf, object, node } from 'prop-types';
import { theme } from 'styled-tools';
import hoistNonReactStatics from 'hoist-non-react-statics';
import styled from './styled.js';
import { a as as } from './as-b6817d40.js';
import Hidden from './Hidden.js';
import { c as HiddenToggle, b as HiddenShow, a as HiddenHide } from './chunk-128e0860.js';
import { a as StepContainer, b as StepNext, c as StepPrevious } from './chunk-dddec8a8.js';
import 'styled-components';
import '@emotion/is-prop-valid';
import 'react-dom';
import './chunk-bbbc8dce.js';
import './chunk-a7ce379e.js';
import './chunk-d8771a86.js';
import './Box.js';
import './chunk-6926af94.js';
import 'constate';

var Component$1 =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Component$$1, _React$Component);

  function Component$$1(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    var _this$props = _this.props,
        register = _this$props.register,
        step = _this$props.step,
        order = _this$props.order;
    register(step, order);
    return _this;
  }

  var _proto = Component$$1.prototype;

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    var _this$props2 = this.props,
        step = _this$props2.step,
        update = _this$props2.update,
        order = _this$props2.order;

    if (prevProps.step !== step || prevProps.order !== order) {
      update(prevProps.step, step, order);
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    var _this$props3 = this.props,
        step = _this$props3.step,
        unregister = _this$props3.unregister;
    unregister(step);
  };

  _proto.render = function render() {
    var _this$props4 = this.props,
        isCurrent = _this$props4.isCurrent,
        step = _this$props4.step;
    return createElement(Hidden, _extends({
      unmount: true,
      visible: isCurrent(step)
    }, this.props));
  };

  return Component$$1;
}(Component);

hoistNonReactStatics(Component$1, Hidden);
var Step = styled(Component$1).withConfig({
  displayName: "Step",
  componentId: "sc-1b10ris-0"
})(["", ";"], theme("Step")); // @ts-ignore

Step.propTypes = {
  step: string.isRequired,
  register: func.isRequired,
  update: func.isRequired,
  unregister: func.isRequired,
  isCurrent: func.isRequired,
  order: number
};
var Step$1 = as("div")(Step);

var toggle = function toggle(props) {
  return function () {
    return props.toggle && props.toggle(props.step);
  };
};

var Component$2 = function Component$$1(props) {
  return createElement(HiddenToggle, _extends({}, props, {
    toggle: toggle(props)
  }));
};

var StepToggle = styled(Component$2).withConfig({
  displayName: "StepToggle",
  componentId: "sc-73h2vf-0"
})(["", ";"], theme("StepToggle")); // @ts-ignore

StepToggle.propTypes = {
  toggle: func.isRequired,
  step: string.isRequired
};
var StepToggle$1 = as("button")(StepToggle);

var show = function show(props) {
  return function () {
    return props.show && props.show(props.step);
  };
};

var Component$3 = function Component$$1(props) {
  return createElement(HiddenShow, _extends({}, props, {
    show: show(props)
  }));
};

var StepShow = styled(Component$3).withConfig({
  displayName: "StepShow",
  componentId: "rrfdz6-0"
})(["", ";"], theme("StepShow")); // @ts-ignore

StepShow.propTypes = {
  show: func.isRequired,
  step: string.isRequired
};
var StepShow$1 = as("button")(StepShow);

var StepHide = styled(HiddenHide).withConfig({
  displayName: "StepHide",
  componentId: "sc-1uq7y3z-0"
})(["", ";"], theme("StepHide"));
var StepHide$1 = as("button")(StepHide);

var Step$2 = Object.assign(Step$1, {
  Container: StepContainer,
  Toggle: StepToggle$1,
  Show: StepShow$1,
  Hide: StepHide$1,
  Next: StepNext,
  Previous: StepPrevious
});

export default Step$2;
